<?php

namespace FORM_BusinessClass;

abstract class BoxQuestion extends Question
{
    private array $possibleResponses; // un dictionnaire qui associe chaque réponse
                                      // possible à un ou plusieurs objets Category

    /**
     * @param array $possibleResponses
     * @param string $content
     * @param array $categories
     */
    public function __construct(array $possibleResponses, string $content, array $categories)
    {
        parent::__construct($content, $categories);
        $this->possibleResponses = $possibleResponses;
    }

    public abstract function responseStrategy();

    public abstract function printStrategy(): string;

    /**
     * @return array
     */
    public function getPossibleResponses(): array
    {
        return $this->possibleResponses;
    }

    /**
     * @param array $possibleResponses
     */
    public function setPossibleResponses(array $possibleResponses): void
    {
        $this->possibleResponses = $possibleResponses;
    }
}